---
product: "AG Grid"
title: "Excel Export - Notes"
description: "Excel notes/comments can be added to exported cells using a callback, exported automatically from the feature, or attached to custom content rows."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-extra-content/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-images/"
    - title: "Excel Tables"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-tables/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Notes

Excel notes/comments can be added to exported cells using a callback, exported automatically from the [Notes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/notes/) feature, or attached to custom content rows.

## Adding Notes to Cells

Use `processNoteCallback` to inject notes during export. The callback is invoked for each exported cell and receives the cell value, column, and row node. Return an `ExcelNote` object to attach a note, `undefined` to keep the default behaviour, or `null` to suppress the note for the current cell.

If a note does not specify an `author`, the Excel document `author` is used. When the document author is not provided, the exporter falls back to `AG Grid`.

#### Excel Export - Basic Notes

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { ContextMenuModule, ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
]);

type OlympicWinner = {
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  defaultExcelExportParams: {
    author: "Export Bot",
    processNoteCallback: (params) => {
      if (params.column.getColId() === "gold" && Number(params.value) >= 5) {
        return {
          text: `Outstanding medal count (${params.value} gold). Flag for performance review.`,
          author: "Review Team",
        };
      }

      return undefined;
    },
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Basic Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-basic/typescript/)

```js
const gridOptions = {
    defaultExcelExportParams: {
        processNoteCallback: (params) => {
            if (params.column.getColId() === 'gold' && Number(params.value) >= 5) {
                return {
                    text: `Outstanding medal count (${params.value} gold).`,
                };
            }
        },
     },

    // other grid options ...
}
```

## Exporting Grid Notes

When the [Notes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/notes/) feature is enabled and `notesDataSource` is configured, cell notes are exported automatically as Excel notes/comments. No callback is needed.

#### Excel Export - Grid Notes

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

type OlympicWinner = {
  id: string;
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const notesDataSource: NotesDataSource = {
  getNote: (params: NotesDataSourceGetNoteParams) =>
    noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
  setNote: (params: NotesDataSourceSetNoteParams) => {
    const key = getNoteKey(params.rowNode.id!, params.column.getColId());

    if (params.note === undefined) {
      noteStore.delete(key);
    } else {
      noteStore.set(key, params.note);
    }
  },
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    id: "1",
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    id: "2",
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    id: "3",
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    id: "4",
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  getRowId: ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  notesDataSource,
  defaultExcelExportParams: {
    author: "Portfolio Ops",
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-grid-notes/typescript/)

### Suppressing Grid Notes

Set `suppressGridNotesExport` to `true` to prevent grid notes from being included in the export. The grid still displays notes, but the exported file will not contain them. Callback-based note injection via `processNoteCallback` still works when this is set.

#### Excel Export - Suppress Grid Notes

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

type OlympicWinner = {
  id: string;
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const notesDataSource: NotesDataSource = {
  getNote: (params: NotesDataSourceGetNoteParams) =>
    noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
  setNote: (params: NotesDataSourceSetNoteParams) => {
    const key = getNoteKey(params.rowNode.id!, params.column.getColId());

    if (params.note === undefined) {
      noteStore.delete(key);
    } else {
      noteStore.set(key, params.note);
    }
  },
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    id: "1",
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    id: "2",
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    id: "3",
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    id: "4",
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  getRowId: ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  notesDataSource,
  defaultExcelExportParams: {
    author: "Portfolio Ops",
    suppressGridNotesExport: true,
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Suppress Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-suppress-grid-notes/typescript/)

```js
const gridOptions = {
    defaultExcelExportParams: {
        suppressGridNotesExport: true,
     },

    // other grid options ...
}
```

### Customising Exported Notes

The `processNoteCallback` can be used to customise existing grid notes before they are exported. For cells that contain grid notes the `processNoteCallback` provides both `excelNote` and `gridNote`.

- `excelNote` - is the note that will be exported to Excel
- `gridNote` - is the source grid note for this cell

The example below shows how the existing `excelNote` text can be updated to include the `updatedAt` value from the underlying `gridNote`.

#### Excel Export - Customising Notes

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

type OlympicWinner = {
  id: string;
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const notesDataSource: NotesDataSource = {
  getNote: (params: NotesDataSourceGetNoteParams) =>
    noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
  setNote: (params: NotesDataSourceSetNoteParams) => {
    const key = getNoteKey(params.rowNode.id!, params.column.getColId());

    if (params.note === undefined) {
      noteStore.delete(key);
    } else {
      noteStore.set(key, params.note);
    }
  },
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    id: "1",
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    id: "2",
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    id: "3",
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    id: "4",
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  getRowId: ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  notesDataSource,
  defaultExcelExportParams: {
    author: "Portfolio Ops",
    processNoteCallback: (params) => {
      if (params.excelNote) {
        return {
          ...params.excelNote,
          text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? "Not recorded"}`,
        };
      }

      // Export a note to Excel for which there is not an existing gridNote
      if (params.column.getColId() === "gold" && Number(params.value) >= 8) {
        return {
          text: "Flag this medal count for the performance review pack.",
        };
      }
    },
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Customising Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-customisation/typescript/)

```js
const gridOptions = {
    notesDataSource,
    defaultExcelExportParams: {
        processNoteCallback: (params) => {
            if (params.excelNote) {
                return {
                    ...params.excelNote,
                    text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? 'Not recorded'}`,
                };
            }
        },
    },

    // other grid options ...
}
```

## Hiding Author

By default, the author name is prepended as bold text in the Excel note body (matching Excel's native behaviour). Set `suppressPrependAuthorToNotes` to `true` to export only the note text. The author is still stored in the Excel workbook's note metadata.

#### Excel Export - Hide Author

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

type OlympicWinner = {
  id: string;
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const notesDataSource: NotesDataSource = {
  getNote: (params: NotesDataSourceGetNoteParams) =>
    noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
  setNote: (params: NotesDataSourceSetNoteParams) => {
    const key = getNoteKey(params.rowNode.id!, params.column.getColId());

    if (params.note === undefined) {
      noteStore.delete(key);
    } else {
      noteStore.set(key, params.note);
    }
  },
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    id: "1",
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    id: "2",
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    id: "3",
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    id: "4",
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  getRowId: ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  notesDataSource,
  defaultExcelExportParams: {
    author: "Portfolio Ops",
    suppressPrependAuthorToNotes: true,
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Hide Author](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-hide-author/typescript/)

```js
const gridOptions = {
    defaultExcelExportParams: {
        author: 'Portfolio Ops',
        suppressPrependAuthorToNotes: true,
     },

    // other grid options ...
}
```

## Adding Notes to Extra Content

Cells in [extra content](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-extra-content/) rows can carry Excel notes via `ExcelCell.note`.

#### Excel Export - Notes on Extra Content

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  ExcelRow,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, ExcelExportModule]);

type OlympicWinner = {
  athlete: string;
  country: string;
  year: number;
  sport: string;
  gold: number;
};

const columnDefs: ColDef<OlympicWinner>[] = [
  { field: "athlete", minWidth: 180 },
  { field: "country", minWidth: 180 },
  { field: "year", maxWidth: 120 },
  { field: "sport", minWidth: 160 },
  { field: "gold", maxWidth: 120 },
];

const rowData: OlympicWinner[] = [
  {
    athlete: "Michael Phelps",
    country: "United States",
    year: 2008,
    sport: "Swimming",
    gold: 8,
  },
  {
    athlete: "Usain Bolt",
    country: "Jamaica",
    year: 2008,
    sport: "Athletics",
    gold: 3,
  },
  {
    athlete: "Simone Biles",
    country: "United States",
    year: 2016,
    sport: "Gymnastics",
    gold: 4,
  },
  {
    athlete: "Katie Ledecky",
    country: "United States",
    year: 2016,
    sport: "Swimming",
    gold: 4,
  },
];

let gridApi: GridApi<OlympicWinner>;

const extraContent: ExcelRow[] = [
  {
    cells: [
      {
        data: { type: "String", value: "Export Summary" },
        styleId: "coverHeading",
        note: {
          text: "This note is added only during export through ExcelCell.note.",
        },
      },
    ],
  },
  { cells: [] },
];

const gridOptions: GridOptions<OlympicWinner> = {
  columnDefs,
  rowData,
  defaultColDef: {
    flex: 1,
    minWidth: 120,
  },
  excelStyles: [
    {
      id: "coverHeading",
      font: {
        bold: true,
        size: 14,
      },
    },
  ],
  defaultExcelExportParams: {
    author: "Portfolio Ops",
    prependContent: extraContent,
  },
};

function onBtExport() {
  gridApi.exportDataAsExcel();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtExport = onBtExport;
}
```

[Live example: Excel Export - Notes on Extra Content](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-extra-content/typescript/)

```js
const gridOptions = {
    defaultExcelExportParams: {
        prependContent: [
            {
                cells: [
                    {
                        data: { type: 'String', value: 'Export Summary' },
                        note: {
                            text: 'This note is added only during export through ExcelCell.note.',
                        },
                    },
                ],
            },
        ],
    },

    // other grid options ...
}
```

## API

### ExcelNote

Properties available on the `ExcelNote` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `text` | `string` |  |  |  |
| `author` | `string` |  |  |  |

### ProcessNoteForExportParams

Properties available on the `ProcessNoteForExportParams&lt;TData = any, TContext = any&gt;` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `gridNote` | `Note` |  |  |  |
| `excelNote` | `ExcelNote` |  |  |  |
| `value` | `any` |  |  |  |
| `accumulatedRowIndex` | `number` |  |  |  |
| `node` | `IRowNode \| null` |  |  |  |
| `column` | `Column` |  |  |  |
| `type` | `string` |  |  |  |
| `parseValue` | `Function` |  |  |  |
| `formatValue` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Excel Export - Notes"
description: "Excel notes/comments can be added to exported cells using a callback, exported automatically from the feature, or attached to custom content rows."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-extra-content/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-images/"
    - title: "Excel Tables"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-tables/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Notes

Excel notes/comments can be added to exported cells using a callback, exported automatically from the [Notes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/notes/) feature, or attached to custom content rows.

## Adding Notes to Cells

Use `processNoteCallback` to inject notes during export. The callback is invoked for each exported cell and receives the cell value, column, and row node. Return an `ExcelNote` object to attach a note, `undefined` to keep the default behaviour, or `null` to suppress the note for the current cell.

If a note does not specify an `author`, the Excel document `author` is used. When the document author is not provided, the exporter falls back to `AG Grid`.

#### Excel Export - Basic Notes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ContextMenuModule, ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Export Bot",
      processNoteCallback: (params) => {
        if (params.column.getColId() === "gold" && Number(params.value) >= 5) {
          return {
            text: `Outstanding medal count (${params.value} gold). Flag for performance review.`,
            author: "Review Team",
          };
        }
        return undefined;
      },
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Basic Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-basic/vue3/)

```ts
<ag-grid-vue
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultExcelExportParams = {
    processNoteCallback: (params) => {
        if (params.column.getColId() === 'gold' && Number(params.value) >= 5) {
            return {
                text: `Outstanding medal count (${params.value} gold).`,
            };
        }
    },
 };
```

## Exporting Grid Notes

When the [Notes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/notes/) feature is enabled and `notesDataSource` is configured, cell notes are exported automatically as Excel notes/comments. No callback is needed.

#### Excel Export - Grid Notes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :notesDataSource="notesDataSource"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :getRowId="getRowId"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const notesDataSource = ref<NotesDataSource | FullWidthNotesDataSource>({
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        id: "1",
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        id: "2",
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        id: "3",
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        id: "4",
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const getRowId = ref<GetRowIdFunc>(
      ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    );
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Portfolio Ops",
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      notesDataSource,
      columnDefs,
      rowData,
      getRowId,
      defaultColDef,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-grid-notes/vue3/)

### Suppressing Grid Notes

Set `suppressGridNotesExport` to `true` to prevent grid notes from being included in the export. The grid still displays notes, but the exported file will not contain them. Callback-based note injection via `processNoteCallback` still works when this is set.

#### Excel Export - Suppress Grid Notes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :notesDataSource="notesDataSource"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :getRowId="getRowId"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const notesDataSource = ref<NotesDataSource | FullWidthNotesDataSource>({
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        id: "1",
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        id: "2",
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        id: "3",
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        id: "4",
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const getRowId = ref<GetRowIdFunc>(
      ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    );
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Portfolio Ops",
      suppressGridNotesExport: true,
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      notesDataSource,
      columnDefs,
      rowData,
      getRowId,
      defaultColDef,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Suppress Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-suppress-grid-notes/vue3/)

```ts
<ag-grid-vue
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultExcelExportParams = {
    suppressGridNotesExport: true,
 };
```

### Customising Exported Notes

The `processNoteCallback` can be used to customise existing grid notes before they are exported. For cells that contain grid notes the `processNoteCallback` provides both `excelNote` and `gridNote`.

- `excelNote` - is the note that will be exported to Excel
- `gridNote` - is the source grid note for this cell

The example below shows how the existing `excelNote` text can be updated to include the `updatedAt` value from the underlying `gridNote`.

#### Excel Export - Customising Notes

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :notesDataSource="notesDataSource"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :getRowId="getRowId"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const notesDataSource = ref<NotesDataSource | FullWidthNotesDataSource>({
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        id: "1",
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        id: "2",
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        id: "3",
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        id: "4",
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const getRowId = ref<GetRowIdFunc>(
      ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    );
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Portfolio Ops",
      processNoteCallback: (params) => {
        if (params.excelNote) {
          return {
            ...params.excelNote,
            text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? "Not recorded"}`,
          };
        }
        // Export a note to Excel for which there is not an existing gridNote
        if (params.column.getColId() === "gold" && Number(params.value) >= 8) {
          return {
            text: "Flag this medal count for the performance review pack.",
          };
        }
      },
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      notesDataSource,
      columnDefs,
      rowData,
      getRowId,
      defaultColDef,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Customising Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-customisation/vue3/)

```ts
<ag-grid-vue
    :notesDataSource="notesDataSource"
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

notesDataSource;
this.defaultExcelExportParams = {
    processNoteCallback: (params) => {
        if (params.excelNote) {
            return {
                ...params.excelNote,
                text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? 'Not recorded'}`,
            };
        }
    },
};
```

## Hiding Author

By default, the author name is prepended as bold text in the Excel note body (matching Excel's native behaviour). Set `suppressPrependAuthorToNotes` to `true` to export only the note text. The author is still stored in the Excel workbook's note metadata.

#### Excel Export - Hide Author

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :notesDataSource="notesDataSource"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :getRowId="getRowId"
          :defaultColDef="defaultColDef"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const notesDataSource = ref<NotesDataSource | FullWidthNotesDataSource>({
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    });
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        id: "1",
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        id: "2",
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        id: "3",
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        id: "4",
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const getRowId = ref<GetRowIdFunc>(
      ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    );
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Portfolio Ops",
      suppressPrependAuthorToNotes: true,
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      notesDataSource,
      columnDefs,
      rowData,
      getRowId,
      defaultColDef,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Hide Author](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-hide-author/vue3/)

```ts
<ag-grid-vue
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultExcelExportParams = {
    author: 'Portfolio Ops',
    suppressPrependAuthorToNotes: true,
 };
```

## Adding Notes to Extra Content

Cells in [extra content](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-extra-content/) rows can carry Excel notes via `ExcelCell.note`.

#### Excel Export - Notes on Extra Content

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  ExcelRow,
  ExcelStyle,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, ExcelExportModule]);

const extraContent: ExcelRow[] = [
  {
    cells: [
      {
        data: { type: "String", value: "Export Summary" },
        styleId: "coverHeading",
        note: {
          text: "This note is added only during export through ExcelCell.note.",
        },
      },
    ],
  },
  { cells: [] },
];

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="container">
      <div class="controls">
        <button v-on:click="onBtExport()">Export</button>
      </div>
      <div class="grid-wrapper">
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :rowData="rowData"
          :defaultColDef="defaultColDef"
          :excelStyles="excelStyles"
          :defaultExcelExportParams="defaultExcelExportParams"></ag-grid-vue>
        </div>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<OlympicWinner> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 180 },
      { field: "country", minWidth: 180 },
      { field: "year", maxWidth: 120 },
      { field: "sport", minWidth: 160 },
      { field: "gold", maxWidth: 120 },
    ]);
    const rowData = ref<OlympicWinner[] | null>([
      {
        athlete: "Michael Phelps",
        country: "United States",
        year: 2008,
        sport: "Swimming",
        gold: 8,
      },
      {
        athlete: "Usain Bolt",
        country: "Jamaica",
        year: 2008,
        sport: "Athletics",
        gold: 3,
      },
      {
        athlete: "Simone Biles",
        country: "United States",
        year: 2016,
        sport: "Gymnastics",
        gold: 4,
      },
      {
        athlete: "Katie Ledecky",
        country: "United States",
        year: 2016,
        sport: "Swimming",
        gold: 4,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 120,
    });
    const excelStyles = ref<ExcelStyle[]>([
      {
        id: "coverHeading",
        font: {
          bold: true,
          size: 14,
        },
      },
    ]);
    const defaultExcelExportParams = ref<ExcelExportParams>({
      author: "Portfolio Ops",
      prependContent: extraContent,
    });

    function onBtExport() {
      gridApi.value.exportDataAsExcel();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      excelStyles,
      defaultExcelExportParams,
      onGridReady,
      onBtExport,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Excel Export - Notes on Extra Content](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-extra-content/vue3/)

```ts
<ag-grid-vue
    :defaultExcelExportParams="defaultExcelExportParams"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultExcelExportParams = {
    prependContent: [
        {
            cells: [
                {
                    data: { type: 'String', value: 'Export Summary' },
                    note: {
                        text: 'This note is added only during export through ExcelCell.note.',
                    },
                },
            ],
        },
    ],
};
```

## API

### ExcelNote

Properties available on the `ExcelNote` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `text` | `string` |  |  |  |
| `author` | `string` |  |  |  |

### ProcessNoteForExportParams

Properties available on the `ProcessNoteForExportParams&lt;TData = any, TContext = any&gt;` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `gridNote` | `Note` |  |  |  |
| `excelNote` | `ExcelNote` |  |  |  |
| `value` | `any` |  |  |  |
| `accumulatedRowIndex` | `number` |  |  |  |
| `node` | `IRowNode \| null` |  |  |  |
| `column` | `Column` |  |  |  |
| `type` | `string` |  |  |  |
| `parseValue` | `Function` |  |  |  |
| `formatValue` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Excel Export - Notes"
description: "Excel notes/comments can be added to exported cells using a callback, exported automatically from the feature, or attached to custom content rows."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-extra-content/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-images/"
    - title: "Excel Tables"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-tables/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Notes

Excel notes/comments can be added to exported cells using a callback, exported automatically from the [Notes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/notes/) feature, or attached to custom content rows.

## Adding Notes to Cells

Use `processNoteCallback` to inject notes during export. The callback is invoked for each exported cell and receives the cell value, column, and row node. Return an `ExcelNote` object to attach a note, `undefined` to keep the default behaviour, or `null` to suppress the note for the current cell.

If a note does not specify an `author`, the Excel document `author` is used. When the document author is not provided, the exporter falls back to `AG Grid`.

#### Excel Export - Basic Notes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ContextMenuModule, ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Export Bot",
      processNoteCallback: (params) => {
        if (params.column.getColId() === "gold" && Number(params.value) >= 5) {
          return {
            text: `Outstanding medal count (${params.value} gold). Flag for performance review.`,
            author: "Review Team",
          };
        }
        return undefined;
      },
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Basic Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-basic/reactFunctionalTs/)

```jsx
const defaultExcelExportParams = useMemo(() => { 
	return {
        processNoteCallback: (params) => {
            if (params.column.getColId() === 'gold' && Number(params.value) >= 5) {
                return {
                    text: `Outstanding medal count (${params.value} gold).`,
                };
            }
        },
     };
}, []);

<AgGridReact defaultExcelExportParams={defaultExcelExportParams} />
```

## Exporting Grid Notes

When the [Notes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/notes/) feature is enabled and `notesDataSource` is configured, cell notes are exported automatically as Excel notes/comments. No callback is needed.

#### Excel Export - Grid Notes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
];

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const notesDataSource = useMemo<
    NotesDataSource | FullWidthNotesDataSource
  >(() => {
    return {
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const getRowId = useCallback(
    ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    [],
  );
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Portfolio Ops",
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                notesDataSource={notesDataSource}
                columnDefs={columnDefs}
                getRowId={getRowId}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-grid-notes/reactFunctionalTs/)

### Suppressing Grid Notes

Set `suppressGridNotesExport` to `true` to prevent grid notes from being included in the export. The grid still displays notes, but the exported file will not contain them. Callback-based note injection via `processNoteCallback` still works when this is set.

#### Excel Export - Suppress Grid Notes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
];

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const notesDataSource = useMemo<
    NotesDataSource | FullWidthNotesDataSource
  >(() => {
    return {
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const getRowId = useCallback(
    ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    [],
  );
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Portfolio Ops",
      suppressGridNotesExport: true,
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                notesDataSource={notesDataSource}
                columnDefs={columnDefs}
                getRowId={getRowId}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Suppress Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-suppress-grid-notes/reactFunctionalTs/)

```jsx
const defaultExcelExportParams = useMemo(() => { 
	return {
        suppressGridNotesExport: true,
     };
}, []);

<AgGridReact defaultExcelExportParams={defaultExcelExportParams} />
```

### Customising Exported Notes

The `processNoteCallback` can be used to customise existing grid notes before they are exported. For cells that contain grid notes the `processNoteCallback` provides both `excelNote` and `gridNote`.

- `excelNote` - is the note that will be exported to Excel
- `gridNote` - is the source grid note for this cell

The example below shows how the existing `excelNote` text can be updated to include the `updatedAt` value from the underlying `gridNote`.

#### Excel Export - Customising Notes

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
];

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const notesDataSource = useMemo<
    NotesDataSource | FullWidthNotesDataSource
  >(() => {
    return {
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const getRowId = useCallback(
    ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    [],
  );
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Portfolio Ops",
      processNoteCallback: (params) => {
        if (params.excelNote) {
          return {
            ...params.excelNote,
            text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? "Not recorded"}`,
          };
        }
        // Export a note to Excel for which there is not an existing gridNote
        if (params.column.getColId() === "gold" && Number(params.value) >= 8) {
          return {
            text: "Flag this medal count for the performance review pack.",
          };
        }
      },
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                notesDataSource={notesDataSource}
                columnDefs={columnDefs}
                getRowId={getRowId}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Customising Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-customisation/reactFunctionalTs/)

```jsx
const notesDataSource = notesDataSource;
const defaultExcelExportParams = useMemo(() => { 
	return {
        processNoteCallback: (params) => {
            if (params.excelNote) {
                return {
                    ...params.excelNote,
                    text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? 'Not recorded'}`,
                };
            }
        },
    };
}, []);

<AgGridReact
    notesDataSource={notesDataSource}
    defaultExcelExportParams={defaultExcelExportParams}
/>
```

## Hiding Author

By default, the author name is prepended as bold text in the Excel note body (matching Excel's native behaviour). Set `suppressPrependAuthorToNotes` to `true` to export only the note text. The author is still stored in the Excel workbook's note metadata.

#### Excel Export - Hide Author

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
];

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;

const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const notesDataSource = useMemo<
    NotesDataSource | FullWidthNotesDataSource
  >(() => {
    return {
      getNote: (params: NotesDataSourceGetNoteParams) =>
        noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
      setNote: (params: NotesDataSourceSetNoteParams) => {
        const key = getNoteKey(params.rowNode.id!, params.column.getColId());
        if (params.note === undefined) {
          noteStore.delete(key);
        } else {
          noteStore.set(key, params.note);
        }
      },
    };
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const getRowId = useCallback(
    ({ data }: GetRowIdParams<OlympicWinner>) => data.id,
    [],
  );
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Portfolio Ops",
      suppressPrependAuthorToNotes: true,
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                notesDataSource={notesDataSource}
                columnDefs={columnDefs}
                getRowId={getRowId}
                defaultColDef={defaultColDef}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Hide Author](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-hide-author/reactFunctionalTs/)

```jsx
const defaultExcelExportParams = useMemo(() => { 
	return {
        author: 'Portfolio Ops',
        suppressPrependAuthorToNotes: true,
     };
}, []);

<AgGridReact defaultExcelExportParams={defaultExcelExportParams} />
```

## Adding Notes to Extra Content

Cells in [extra content](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-extra-content/) rows can carry Excel notes via `ExcelCell.note`.

#### Excel Export - Notes on Extra Content

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  ExcelRow,
  ExcelStyle,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";
import { OlympicWinner } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, ExcelExportModule];

const extraContent: ExcelRow[] = [
  {
    cells: [
      {
        data: { type: "String", value: "Export Summary" },
        styleId: "coverHeading",
        note: {
          text: "This note is added only during export through ExcelCell.note.",
        },
      },
    ],
  },
  { cells: [] },
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<OlympicWinner>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<OlympicWinner[]>([
    {
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ]);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 120,
    };
  }, []);
  const excelStyles = useMemo<ExcelStyle[]>(() => {
    return [
      {
        id: "coverHeading",
        font: {
          bold: true,
          size: 14,
        },
      },
    ];
  }, []);
  const defaultExcelExportParams = useMemo<ExcelExportParams>(() => {
    return {
      author: "Portfolio Ops",
      prependContent: extraContent,
    };
  }, []);

  const onBtExport = useCallback(() => {
    gridRef.current!.api.exportDataAsExcel();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="container">
          <div className="controls">
            <button onClick={onBtExport}>Export</button>
          </div>
          <div className="grid-wrapper">
            <div style={gridStyle}>
              <AgGridReact<OlympicWinner>
                ref={gridRef}
                rowData={rowData}
                columnDefs={columnDefs}
                defaultColDef={defaultColDef}
                excelStyles={excelStyles}
                defaultExcelExportParams={defaultExcelExportParams}
              />
            </div>
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Excel Export - Notes on Extra Content](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-extra-content/reactFunctionalTs/)

```jsx
const defaultExcelExportParams = useMemo(() => { 
	return {
        prependContent: [
            {
                cells: [
                    {
                        data: { type: 'String', value: 'Export Summary' },
                        note: {
                            text: 'This note is added only during export through ExcelCell.note.',
                        },
                    },
                ],
            },
        ],
    };
}, []);

<AgGridReact defaultExcelExportParams={defaultExcelExportParams} />
```

## API

### ExcelNote

Properties available on the `ExcelNote` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `text` | `string` |  |  |  |
| `author` | `string` |  |  |  |

### ProcessNoteForExportParams

Properties available on the `ProcessNoteForExportParams&lt;TData = any, TContext = any&gt;` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `gridNote` | `Note` |  |  |  |
| `excelNote` | `ExcelNote` |  |  |  |
| `value` | `any` |  |  |  |
| `accumulatedRowIndex` | `number` |  |  |  |
| `node` | `IRowNode \| null` |  |  |  |
| `column` | `Column` |  |  |  |
| `type` | `string` |  |  |  |
| `parseValue` | `Function` |  |  |  |
| `formatValue` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |


---
product: "AG Grid"
title: "Excel Export - Notes"
description: "Excel notes/comments can be added to exported cells using a callback, exported automatically from the feature, or attached to custom content rows."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Styles"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-styles/"
    - title: "Formulas"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-formulas/"
    - title: "Extra Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-extra-content/"
    - title: "Customising Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-customising-content/"
    - title: "Images"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-images/"
    - title: "Excel Tables"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-tables/"
    - title: "Multiple Sheets"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-multiple-sheets/"
    - title: "Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-rows/"
    - title: "Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-columns/"
    - title: "Freezing Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-freeze/"
    - title: "Data Types"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-data-types/"
    - title: "Hyperlinks"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-hyperlinks/"
    - title: "Master Detail"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-master-detail/"
    - title: "Page Setup"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-page-setup/"
    - title: "Data Protection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-data-protection/"
    - title: "API Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Excel Export - Notes

Excel notes/comments can be added to exported cells using a callback, exported automatically from the [Notes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/notes/) feature, or attached to custom content rows.

## Adding Notes to Cells

Use `processNoteCallback` to inject notes during export. The callback is invoked for each exported cell and receives the cell value, column, and row node. Return an `ExcelNote` object to attach a note, `undefined` to keep the default behaviour, or `null` to suppress the note for the current cell.

If a note does not specify an `author`, the Excel document `author` is used. When the document author is not provided, the exporter falls back to `AG Grid`.

#### Excel Export - Basic Notes

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ContextMenuModule, ExcelExportModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  defaultExcelExportParams: ExcelExportParams = {
    author: "Export Bot",
    processNoteCallback: (params) => {
      if (params.column.getColId() === "gold" && Number(params.value) >= 5) {
        return {
          text: `Outstanding medal count (${params.value} gold). Flag for performance review.`,
          author: "Review Team",
        };
      }
      return undefined;
    },
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}
```

[Live example: Excel Export - Basic Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-basic/angular/)

```ts
<ag-grid-angular
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

this.defaultExcelExportParams = {
    processNoteCallback: (params) => {
        if (params.column.getColId() === 'gold' && Number(params.value) >= 5) {
            return {
                text: `Outstanding medal count (${params.value} gold).`,
            };
        }
    },
 };
```

## Exporting Grid Notes

When the [Notes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/notes/) feature is enabled and `notesDataSource` is configured, cell notes are exported automatically as Excel notes/comments. No callback is needed.

#### Excel Export - Grid Notes

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [notesDataSource]="notesDataSource"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [getRowId]="getRowId"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  notesDataSource: NotesDataSource | FullWidthNotesDataSource = {
    getNote: (params: NotesDataSourceGetNoteParams) =>
      noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
    setNote: (params: NotesDataSourceSetNoteParams) => {
      const key = getNoteKey(params.rowNode.id!, params.column.getColId());
      if (params.note === undefined) {
        noteStore.delete(key);
      } else {
        noteStore.set(key, params.note);
      }
    },
  };
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  getRowId: GetRowIdFunc = ({ data }: GetRowIdParams<OlympicWinner>) => data.id;
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  defaultExcelExportParams: ExcelExportParams = {
    author: "Portfolio Ops",
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;
const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);
```

[Live example: Excel Export - Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-grid-notes/angular/)

### Suppressing Grid Notes

Set `suppressGridNotesExport` to `true` to prevent grid notes from being included in the export. The grid still displays notes, but the exported file will not contain them. Callback-based note injection via `processNoteCallback` still works when this is set.

#### Excel Export - Suppress Grid Notes

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [notesDataSource]="notesDataSource"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [getRowId]="getRowId"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  notesDataSource: NotesDataSource | FullWidthNotesDataSource = {
    getNote: (params: NotesDataSourceGetNoteParams) =>
      noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
    setNote: (params: NotesDataSourceSetNoteParams) => {
      const key = getNoteKey(params.rowNode.id!, params.column.getColId());
      if (params.note === undefined) {
        noteStore.delete(key);
      } else {
        noteStore.set(key, params.note);
      }
    },
  };
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  getRowId: GetRowIdFunc = ({ data }: GetRowIdParams<OlympicWinner>) => data.id;
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  defaultExcelExportParams: ExcelExportParams = {
    author: "Portfolio Ops",
    suppressGridNotesExport: true,
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;
const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);
```

[Live example: Excel Export - Suppress Grid Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-suppress-grid-notes/angular/)

```ts
<ag-grid-angular
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

this.defaultExcelExportParams = {
    suppressGridNotesExport: true,
 };
```

### Customising Exported Notes

The `processNoteCallback` can be used to customise existing grid notes before they are exported. For cells that contain grid notes the `processNoteCallback` provides both `excelNote` and `gridNote`.

- `excelNote` - is the note that will be exported to Excel
- `gridNote` - is the source grid note for this cell

The example below shows how the existing `excelNote` text can be updated to include the `updatedAt` value from the underlying `gridNote`.

#### Excel Export - Customising Notes

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [notesDataSource]="notesDataSource"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [getRowId]="getRowId"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  notesDataSource: NotesDataSource | FullWidthNotesDataSource = {
    getNote: (params: NotesDataSourceGetNoteParams) =>
      noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
    setNote: (params: NotesDataSourceSetNoteParams) => {
      const key = getNoteKey(params.rowNode.id!, params.column.getColId());
      if (params.note === undefined) {
        noteStore.delete(key);
      } else {
        noteStore.set(key, params.note);
      }
    },
  };
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  getRowId: GetRowIdFunc = ({ data }: GetRowIdParams<OlympicWinner>) => data.id;
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  defaultExcelExportParams: ExcelExportParams = {
    author: "Portfolio Ops",
    processNoteCallback: (params) => {
      if (params.excelNote) {
        return {
          ...params.excelNote,
          text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? "Not recorded"}`,
        };
      }
      // Export a note to Excel for which there is not an existing gridNote
      if (params.column.getColId() === "gold" && Number(params.value) >= 8) {
        return {
          text: "Flag this medal count for the performance review pack.",
        };
      }
    },
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;
const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);
```

[Live example: Excel Export - Customising Notes](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-customisation/angular/)

```ts
<ag-grid-angular
    [notesDataSource]="notesDataSource"
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

notesDataSource;
this.defaultExcelExportParams = {
    processNoteCallback: (params) => {
        if (params.excelNote) {
            return {
                ...params.excelNote,
                text: `${params.excelNote.text}\n\nUpdated: ${params.gridNote?.updatedAt ?? 'Not recorded'}`,
            };
        }
    },
};
```

## Hiding Author

By default, the author name is prepended as bold text in the Excel note body (matching Excel's native behaviour). Set `suppressPrependAuthorToNotes` to `true` to export only the note text. The author is still stored in the Excel workbook's note metadata.

#### Excel Export - Hide Author

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  FullWidthNotesDataSource,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Note,
  NotesDataSource,
  NotesDataSourceGetNoteParams,
  NotesDataSourceSetNoteParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ContextMenuModule,
  ExcelExportModule,
  NotesModule,
]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [notesDataSource]="notesDataSource"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [getRowId]="getRowId"
        [defaultColDef]="defaultColDef"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  notesDataSource: NotesDataSource | FullWidthNotesDataSource = {
    getNote: (params: NotesDataSourceGetNoteParams) =>
      noteStore.get(getNoteKey(params.rowNode.id!, params.column.getColId())),
    setNote: (params: NotesDataSourceSetNoteParams) => {
      const key = getNoteKey(params.rowNode.id!, params.column.getColId());
      if (params.note === undefined) {
        noteStore.delete(key);
      } else {
        noteStore.set(key, params.note);
      }
    },
  };
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      id: "1",
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      id: "2",
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      id: "3",
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      id: "4",
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  getRowId: GetRowIdFunc = ({ data }: GetRowIdParams<OlympicWinner>) => data.id;
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  defaultExcelExportParams: ExcelExportParams = {
    author: "Portfolio Ops",
    suppressPrependAuthorToNotes: true,
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}

const getNoteKey = (rowId: string, colId: string) => `${rowId}::${colId}`;
const noteStore = new Map<string, Note>([
  [
    getNoteKey("1", "athlete"),
    {
      text: "Confirm the athlete biography before publishing the desk report.",
      author: "Maya",
      updatedAt: "29 Mar 2026, 09:15",
    },
  ],
  [
    getNoteKey("3", "country"),
    {
      text: "Check the latest federation naming guidance for this country.",
      updatedAt: "27 Mar 2026, 14:30",
    },
  ],
]);
```

[Live example: Excel Export - Hide Author](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-hide-author/angular/)

```ts
<ag-grid-angular
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

this.defaultExcelExportParams = {
    author: 'Portfolio Ops',
    suppressPrependAuthorToNotes: true,
 };
```

## Adding Notes to Extra Content

Cells in [extra content](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-extra-content/) rows can carry Excel notes via `ExcelCell.note`.

#### Excel Export - Notes on Extra Content

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ExcelExportParams,
  ExcelRow,
  ExcelStyle,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { ExcelExportModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, ExcelExportModule]);
import { OlympicWinner } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="container">
    <div class="controls">
      <button (click)="onBtExport()">Export</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [defaultColDef]="defaultColDef"
        [excelStyles]="excelStyles"
        [defaultExcelExportParams]="defaultExcelExportParams"
        (gridReady)="onGridReady($event)"
      />
    </div>
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<OlympicWinner>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 180 },
    { field: "country", minWidth: 180 },
    { field: "year", maxWidth: 120 },
    { field: "sport", minWidth: 160 },
    { field: "gold", maxWidth: 120 },
  ];
  rowData: OlympicWinner[] | null = [
    {
      athlete: "Michael Phelps",
      country: "United States",
      year: 2008,
      sport: "Swimming",
      gold: 8,
    },
    {
      athlete: "Usain Bolt",
      country: "Jamaica",
      year: 2008,
      sport: "Athletics",
      gold: 3,
    },
    {
      athlete: "Simone Biles",
      country: "United States",
      year: 2016,
      sport: "Gymnastics",
      gold: 4,
    },
    {
      athlete: "Katie Ledecky",
      country: "United States",
      year: 2016,
      sport: "Swimming",
      gold: 4,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 120,
  };
  excelStyles: ExcelStyle[] = [
    {
      id: "coverHeading",
      font: {
        bold: true,
        size: 14,
      },
    },
  ];
  defaultExcelExportParams: ExcelExportParams = {
    author: "Portfolio Ops",
    prependContent: extraContent,
  };

  onBtExport() {
    this.gridApi.exportDataAsExcel();
  }

  onGridReady(params: GridReadyEvent<OlympicWinner>) {
    this.gridApi = params.api;
  }
}

const extraContent: ExcelRow[] = [
  {
    cells: [
      {
        data: { type: "String", value: "Export Summary" },
        styleId: "coverHeading",
        note: {
          text: "This note is added only during export through ExcelCell.note.",
        },
      },
    ],
  },
  { cells: [] },
];
```

[Live example: Excel Export - Notes on Extra Content](https://www.ag-grid.com/archive/36.2.0/examples/excel-export-notes/excel-export-notes-extra-content/angular/)

```ts
<ag-grid-angular
    [defaultExcelExportParams]="defaultExcelExportParams"
    /* other grid options ... */ />

this.defaultExcelExportParams = {
    prependContent: [
        {
            cells: [
                {
                    data: { type: 'String', value: 'Export Summary' },
                    note: {
                        text: 'This note is added only during export through ExcelCell.note.',
                    },
                },
            ],
        },
    ],
};
```

## API

### ExcelNote

Properties available on the `ExcelNote` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `text` | `string` |  |  |  |
| `author` | `string` |  |  |  |

### ProcessNoteForExportParams

Properties available on the `ProcessNoteForExportParams&lt;TData = any, TContext = any&gt;` interface.

See [Notes](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export-notes/) for more information.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `gridNote` | `Note` |  |  |  |
| `excelNote` | `ExcelNote` |  |  |  |
| `value` | `any` |  |  |  |
| `accumulatedRowIndex` | `number` |  |  |  |
| `node` | `IRowNode \| null` |  |  |  |
| `column` | `Column` |  |  |  |
| `type` | `string` |  |  |  |
| `parseValue` | `Function` |  |  |  |
| `formatValue` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |
